module Encoding.Base16
  ( enc16
  , dec16
  ) where

import qualified Data.ByteString.Char8 as C
import Data.ByteString.UTF8 as BSU
import qualified Codec.Binary.Base16 as B16

dec16 :: String -> String
dec16 input =
   case B16.decode (BSU.fromString input) of
     Right decoded -> C.unpack decoded
     Left _ -> "Error decoding Base16.\n"

enc16 :: String -> String
enc16 = C.unpack . B16.encode . BSU.fromString
