module Encoding.Base32
  ( enc32
  , dec32
  ) where


import Data.ByteString.UTF8 as BSU      -- from utf8-string
import qualified Data.ByteString.Char8 as C
import qualified Codec.Binary.Base32 as B32

dec32 :: String -> String
-- dec32 = C.unpack . U.fromRight . B32.decode . BSU.fromString
dec32 input =
   case B32.decode (BSU.fromString input) of
     Right decoded -> C.unpack decoded
     Left _ -> "Error decoding Base32.\n"

enc32 :: String -> String
enc32 = C.unpack . B32.encode . BSU.fromString
